/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 2

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         parse_events_parse
#define yylex           parse_events_lex
#define yyerror         parse_events_error
#define yydebug         parse_events_debug
#define yynerrs         parse_events_nerrs


/* Copy the first part of user declarations.  */
#line 7 "util/parse-events.y" /* yacc.c:339  */


#define YYDEBUG 1

#include <errno.h>
#include <fnmatch.h>
#include <stdio.h>
#include <linux/compiler.h>
#include <linux/types.h>
#include <linux/zalloc.h>
#include "pmu.h"
#include "pmus.h"
#include "evsel.h"
#include "parse-events.h"
#include "parse-events-bison.h"

int parse_events_lex(YYSTYPE * yylval_param, YYLTYPE * yylloc_param , void *yyscanner);
void parse_events_error(YYLTYPE *loc, void *parse_state, void *scanner, char const *msg);

#define PE_ABORT(val) \
do { \
	if (val == -ENOMEM) \
		YYNOMEM; \
	YYABORT; \
} while (0)

static struct list_head* alloc_list(void)
{
	struct list_head *list;

	list = malloc(sizeof(*list));
	if (!list)
		return NULL;

	INIT_LIST_HEAD(list);
	return list;
}

static void free_list_evsel(struct list_head* list_evsel)
{
	struct evsel *evsel, *tmp;

	list_for_each_entry_safe(evsel, tmp, list_evsel, core.node) {
		list_del_init(&evsel->core.node);
		evsel__delete(evsel);
	}
	free(list_evsel);
}


#line 123 "util/parse-events-bison.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "parse-events-bison.h".  */
#ifndef YY_PARSE_EVENTS_UTIL_PARSE_EVENTS_BISON_H_INCLUDED
# define YY_PARSE_EVENTS_UTIL_PARSE_EVENTS_BISON_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int parse_events_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    PE_START_EVENTS = 258,
    PE_START_TERMS = 259,
    PE_VALUE = 260,
    PE_VALUE_SYM_HW = 261,
    PE_VALUE_SYM_SW = 262,
    PE_TERM = 263,
    PE_VALUE_SYM_TOOL = 264,
    PE_EVENT_NAME = 265,
    PE_RAW = 266,
    PE_NAME = 267,
    PE_MODIFIER_EVENT = 268,
    PE_MODIFIER_BP = 269,
    PE_BP_COLON = 270,
    PE_BP_SLASH = 271,
    PE_LEGACY_CACHE = 272,
    PE_PREFIX_MEM = 273,
    PE_ERROR = 274,
    PE_DRV_CFG_TERM = 275,
    PE_TERM_HW = 276
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 112 "util/parse-events.y" /* yacc.c:355  */

	char *str;
	u64 num;
	struct list_head *list_evsel;
	struct list_head *list_terms;
	struct parse_events_term *term;
	struct tracepoint_name {
		char *sys;
		char *event;
	} tracepoint_name;
	struct hardware_term {
		char *str;
		u64 num;
	} hardware_term;

#line 201 "util/parse-events-bison.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int parse_events_parse (void *_parse_state, void *scanner);

#endif /* !YY_PARSE_EVENTS_UTIL_PARSE_EVENTS_BISON_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 231 "util/parse-events-bison.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  41
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   137

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  28
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  28
/* YYNRULES -- Number of rules.  */
#define YYNRULES  71
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  115

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   276

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    22,     2,     2,    26,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    23,     2,
       2,    27,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    24,     2,    25,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   130,   130,   132,   134,   143,   153,   163,   165,   168,
     187,   190,   199,   208,   218,   220,   223,   247,   250,   263,
     265,   266,   267,   268,   269,   270,   271,   274,   361,   383,
     385,   388,   408,   425,   440,   462,   482,   501,   521,   540,
     567,   575,   594,   620,   625,   630,   635,   640,   645,   656,
     669,   681,   681,   681,   684,   697,   710,   723,   737,   750,
     763,   777,   790,   803,   817,   829,   842,   859,   859,   861,
     861,   861
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "PE_START_EVENTS", "PE_START_TERMS",
  "PE_VALUE", "PE_VALUE_SYM_HW", "PE_VALUE_SYM_SW", "PE_TERM",
  "PE_VALUE_SYM_TOOL", "PE_EVENT_NAME", "PE_RAW", "PE_NAME",
  "PE_MODIFIER_EVENT", "PE_MODIFIER_BP", "PE_BP_COLON", "PE_BP_SLASH",
  "PE_LEGACY_CACHE", "PE_PREFIX_MEM", "PE_ERROR", "PE_DRV_CFG_TERM",
  "PE_TERM_HW", "','", "':'", "'{'", "'}'", "'/'", "'='", "$accept",
  "start", "start_events", "groups", "group", "group_def", "events",
  "event", "event_mod", "event_name", "event_def", "event_pmu",
  "value_sym", "event_legacy_symbol", "event_legacy_cache",
  "event_legacy_mem", "event_legacy_tracepoint", "tracepoint_name",
  "event_legacy_numeric", "event_legacy_raw", "opt_event_config",
  "opt_pmu_config", "start_terms", "event_config", "name_or_raw",
  "event_term", "sep_dc", "sep_slash_slash_dc", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    44,    58,   123,   125,    47,    61
};
# endif

#define YYPACT_NINF -18

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-18)))

#define YYTABLE_NINF -54

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int8 yypact[] =
{
      66,    -3,   100,     5,   -13,   -18,   -18,    42,    98,    -8,
      51,    -8,    25,    81,   -18,     9,   -18,    37,   -18,   -18,
      63,   -18,   -18,    71,   -18,    41,    41,    41,    -8,    41,
      41,    11,    62,    73,    74,   -18,   -18,   -18,    84,    86,
     -18,   -18,   109,   -18,    92,   -18,    96,   -18,     8,   -18,
     113,    81,    15,   -18,   -18,   -18,    -4,   101,   -18,    -3,
     115,   -18,    31,   -18,   -18,   -18,   -18,   -18,   -18,   -18,
     -18,    50,   100,    61,    -8,   -18,   -18,    18,   -18,   102,
     -18,    24,   116,   124,   -18,    81,   -18,   -18,   -18,   -18,
      27,   -18,   -18,   -18,   -18,   -18,   -18,   -18,   -18,   -18,
     -18,   -18,   -18,   -18,   -18,   -18,    -8,    -2,   -18,   -18,
     -18,   117,   -18,    -8,   -18
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     0,     0,    29,    30,    71,     0,    45,
      68,    45,     0,     0,     2,     4,     7,    10,     8,    15,
      17,    19,    20,    71,    21,    68,    68,    68,    45,    68,
      68,    65,    54,    59,    58,    66,    60,     3,    48,     0,
      50,     1,     0,    70,     0,    33,    68,    18,     0,    42,
      67,     0,     0,    27,    28,    34,    45,     0,    14,     0,
       0,    16,     0,    32,    67,    22,    23,    24,    39,    25,
      26,     0,     0,     0,    45,    69,    44,     0,    40,     0,
      47,     0,     0,     0,    38,     0,    12,     5,     6,     9,
       0,    64,    63,    51,    52,    53,    62,    61,    49,    56,
      57,    55,    41,    43,    11,    46,    45,    45,    13,    31,
      37,     0,    36,    45,    35
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -18,   -18,   -18,   -18,    75,   -18,    82,     0,   -18,   -18,
     127,   -18,   -18,   -18,   -18,   -18,   -18,   -18,   -18,   -18,
     -11,   -18,   -18,   -15,   -17,    60,    54,   114
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     3,    14,    15,    16,    17,    57,    58,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      49,    53,    37,    38,    39,    40,    54,    45
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int8 yytable[] =
{
      55,    18,     4,     5,     6,    41,     7,     8,     9,    10,
      42,    82,    83,   111,    11,    12,    31,    68,    48,    32,
      33,    13,    48,    31,    48,    34,    32,    33,    35,    36,
      56,    59,    34,    77,    76,    35,    36,    81,    71,    31,
      72,    80,    32,    33,   103,    84,    72,    90,    34,    72,
     105,    35,    36,   109,    97,    91,   101,    75,    92,    88,
      60,    93,    94,   102,    64,    43,    99,    95,    44,     1,
       2,    96,    93,    94,    50,    51,    61,    52,    95,    65,
      66,    67,   100,    69,    70,   108,     4,     5,     6,   -51,
       7,     8,     9,    46,    43,   110,   112,    62,    11,    12,
     -52,   -53,   114,     4,     5,     6,    72,     7,    31,     9,
      46,    32,    33,    73,    74,    11,    12,    34,    75,    50,
      35,    36,    52,    85,    85,    78,    86,   104,    89,   107,
     106,   113,    98,    79,    87,    47,     0,    63
};

static const yytype_int8 yycheck[] =
{
      11,     1,     5,     6,     7,     0,     9,    10,    11,    12,
      23,    15,    16,    15,    17,    18,     8,    28,    26,    11,
      12,    24,    26,     8,    26,    17,    11,    12,    20,    21,
       5,    22,    17,    48,    26,    20,    21,    52,    27,     8,
      22,    26,    11,    12,    26,    56,    22,    62,    17,    22,
      26,    20,    21,    26,    71,     5,    73,    26,     8,    59,
      23,    11,    12,    74,    23,    23,     5,    17,    26,     3,
       4,    21,    11,    12,    23,    24,    13,    26,    17,    25,
      26,    27,    21,    29,    30,    85,     5,     6,     7,    27,
       9,    10,    11,    12,    23,   106,   107,    26,    17,    18,
      27,    27,   113,     5,     6,     7,    22,     9,     8,    11,
      12,    11,    12,    27,     5,    17,    18,    17,    26,    23,
      20,    21,    26,    22,    22,    12,    25,    25,    13,     5,
      14,    14,    72,    51,    59,     8,    -1,    23
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,    29,     5,     6,     7,     9,    10,    11,
      12,    17,    18,    24,    30,    31,    32,    33,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,     8,    11,    12,    17,    20,    21,    50,    51,    52,
      53,     0,    23,    23,    26,    55,    12,    38,    26,    48,
      23,    24,    26,    49,    54,    48,     5,    34,    35,    22,
      23,    13,    26,    55,    23,    54,    54,    54,    48,    54,
      54,    27,    22,    27,     5,    26,    26,    51,    12,    34,
      26,    51,    15,    16,    48,    22,    25,    32,    35,    13,
      51,     5,     8,    11,    12,    17,    21,    52,    53,     5,
      21,    52,    48,    26,    25,    26,    14,     5,    35,    26,
      48,    15,    48,    14,    48
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    28,    29,    29,    30,    31,    31,    31,    31,    32,
      32,    33,    33,    34,    34,    35,    36,    36,    37,    37,
      38,    38,    38,    38,    38,    38,    38,    39,    39,    40,
      40,    41,    41,    41,    42,    43,    43,    43,    43,    44,
      45,    46,    47,    48,    48,    48,    49,    49,    50,    51,
      51,    52,    52,    52,    53,    53,    53,    53,    53,    53,
      53,    53,    53,    53,    53,    53,    53,    54,    54,    55,
      55,    55
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     1,     3,     3,     1,     1,     3,
       1,     4,     3,     3,     1,     1,     2,     1,     2,     1,
       1,     1,     2,     2,     2,     2,     2,     2,     2,     1,
       1,     4,     2,     2,     2,     7,     5,     5,     3,     2,
       3,     4,     2,     3,     2,     0,     3,     2,     1,     3,
       1,     1,     1,     1,     1,     3,     3,     3,     1,     1,
       1,     3,     3,     3,     3,     1,     1,     1,     0,     2,
       1,     0
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, _parse_state, scanner, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location, _parse_state, scanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, void *_parse_state, void *scanner)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  YYUSE (_parse_state);
  YYUSE (scanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, void *_parse_state, void *scanner)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, _parse_state, scanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, void *_parse_state, void *scanner)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       , _parse_state, scanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, _parse_state, scanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, void *_parse_state, void *scanner)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (_parse_state);
  YYUSE (scanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yytype)
    {
          case 10: /* PE_EVENT_NAME  */
#line 83 "util/parse-events.y" /* yacc.c:1257  */
      { free (((*yyvaluep).str)); }
#line 1217 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 11: /* PE_RAW  */
#line 83 "util/parse-events.y" /* yacc.c:1257  */
      { free (((*yyvaluep).str)); }
#line 1223 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 12: /* PE_NAME  */
#line 83 "util/parse-events.y" /* yacc.c:1257  */
      { free (((*yyvaluep).str)); }
#line 1229 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 13: /* PE_MODIFIER_EVENT  */
#line 83 "util/parse-events.y" /* yacc.c:1257  */
      { free (((*yyvaluep).str)); }
#line 1235 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 14: /* PE_MODIFIER_BP  */
#line 83 "util/parse-events.y" /* yacc.c:1257  */
      { free (((*yyvaluep).str)); }
#line 1241 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 17: /* PE_LEGACY_CACHE  */
#line 83 "util/parse-events.y" /* yacc.c:1257  */
      { free (((*yyvaluep).str)); }
#line 1247 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 20: /* PE_DRV_CFG_TERM  */
#line 83 "util/parse-events.y" /* yacc.c:1257  */
      { free (((*yyvaluep).str)); }
#line 1253 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 21: /* PE_TERM_HW  */
#line 109 "util/parse-events.y" /* yacc.c:1257  */
      { free (((*yyvaluep).hardware_term).str); }
#line 1259 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 31: /* groups  */
#line 105 "util/parse-events.y" /* yacc.c:1257  */
      { free_list_evsel (((*yyvaluep).list_evsel)); }
#line 1265 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 32: /* group  */
#line 105 "util/parse-events.y" /* yacc.c:1257  */
      { free_list_evsel (((*yyvaluep).list_evsel)); }
#line 1271 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 33: /* group_def  */
#line 105 "util/parse-events.y" /* yacc.c:1257  */
      { free_list_evsel (((*yyvaluep).list_evsel)); }
#line 1277 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 34: /* events  */
#line 105 "util/parse-events.y" /* yacc.c:1257  */
      { free_list_evsel (((*yyvaluep).list_evsel)); }
#line 1283 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 35: /* event  */
#line 105 "util/parse-events.y" /* yacc.c:1257  */
      { free_list_evsel (((*yyvaluep).list_evsel)); }
#line 1289 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 36: /* event_mod  */
#line 105 "util/parse-events.y" /* yacc.c:1257  */
      { free_list_evsel (((*yyvaluep).list_evsel)); }
#line 1295 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 37: /* event_name  */
#line 105 "util/parse-events.y" /* yacc.c:1257  */
      { free_list_evsel (((*yyvaluep).list_evsel)); }
#line 1301 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 38: /* event_def  */
#line 105 "util/parse-events.y" /* yacc.c:1257  */
      { free_list_evsel (((*yyvaluep).list_evsel)); }
#line 1307 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 39: /* event_pmu  */
#line 105 "util/parse-events.y" /* yacc.c:1257  */
      { free_list_evsel (((*yyvaluep).list_evsel)); }
#line 1313 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 41: /* event_legacy_symbol  */
#line 105 "util/parse-events.y" /* yacc.c:1257  */
      { free_list_evsel (((*yyvaluep).list_evsel)); }
#line 1319 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 42: /* event_legacy_cache  */
#line 105 "util/parse-events.y" /* yacc.c:1257  */
      { free_list_evsel (((*yyvaluep).list_evsel)); }
#line 1325 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 43: /* event_legacy_mem  */
#line 105 "util/parse-events.y" /* yacc.c:1257  */
      { free_list_evsel (((*yyvaluep).list_evsel)); }
#line 1331 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 44: /* event_legacy_tracepoint  */
#line 105 "util/parse-events.y" /* yacc.c:1257  */
      { free_list_evsel (((*yyvaluep).list_evsel)); }
#line 1337 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 45: /* tracepoint_name  */
#line 107 "util/parse-events.y" /* yacc.c:1257  */
      { free (((*yyvaluep).tracepoint_name).sys); free (((*yyvaluep).tracepoint_name).event); }
#line 1343 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 46: /* event_legacy_numeric  */
#line 105 "util/parse-events.y" /* yacc.c:1257  */
      { free_list_evsel (((*yyvaluep).list_evsel)); }
#line 1349 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 47: /* event_legacy_raw  */
#line 105 "util/parse-events.y" /* yacc.c:1257  */
      { free_list_evsel (((*yyvaluep).list_evsel)); }
#line 1355 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 48: /* opt_event_config  */
#line 89 "util/parse-events.y" /* yacc.c:1257  */
      { parse_events_terms__delete (((*yyvaluep).list_terms)); }
#line 1361 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 49: /* opt_pmu_config  */
#line 89 "util/parse-events.y" /* yacc.c:1257  */
      { parse_events_terms__delete (((*yyvaluep).list_terms)); }
#line 1367 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 51: /* event_config  */
#line 89 "util/parse-events.y" /* yacc.c:1257  */
      { parse_events_terms__delete (((*yyvaluep).list_terms)); }
#line 1373 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 52: /* name_or_raw  */
#line 83 "util/parse-events.y" /* yacc.c:1257  */
      { free (((*yyvaluep).str)); }
#line 1379 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;

    case 53: /* event_term  */
#line 85 "util/parse-events.y" /* yacc.c:1257  */
      { parse_events_term__delete (((*yyvaluep).term)); }
#line 1385 "util/parse-events-bison.c" /* yacc.c:1257  */
        break;


      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void *_parse_state, void *scanner)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc, scanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:
#line 135 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct parse_events_state *parse_state = _parse_state;

	/* frees $1 */
	parse_events_update_lists((yyvsp[0].list_evsel), &parse_state->list);
}
#line 1684 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 5:
#line 144 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct list_head *list  = (yyvsp[-2].list_evsel);
	struct list_head *group = (yyvsp[0].list_evsel);

	/* frees $3 */
	parse_events_update_lists(group, list);
	(yyval.list_evsel) = list;
}
#line 1697 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 6:
#line 154 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct list_head *list  = (yyvsp[-2].list_evsel);
	struct list_head *event = (yyvsp[0].list_evsel);

	/* frees $3 */
	parse_events_update_lists(event, list);
	(yyval.list_evsel) = list;
}
#line 1710 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 9:
#line 169 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct list_head *list = (yyvsp[-2].list_evsel);
	int err;

	err = parse_events__modifier_group(list, (yyvsp[0].str));
	free((yyvsp[0].str));
	if (err) {
		struct parse_events_state *parse_state = _parse_state;
		struct parse_events_error *error = parse_state->error;

		parse_events_error__handle(error, (yylsp[0]).first_column,
					   strdup("Bad modifier"), NULL);
		free_list_evsel(list);
		YYABORT;
	}
	(yyval.list_evsel) = list;
}
#line 1732 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 11:
#line 191 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct list_head *list = (yyvsp[-1].list_evsel);

	/* Takes ownership of $1. */
	parse_events__set_leader((yyvsp[-3].str), list);
	(yyval.list_evsel) = list;
}
#line 1744 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 12:
#line 200 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct list_head *list = (yyvsp[-1].list_evsel);

	parse_events__set_leader(NULL, list);
	(yyval.list_evsel) = list;
}
#line 1755 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 13:
#line 209 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct list_head *event = (yyvsp[0].list_evsel);
	struct list_head *list  = (yyvsp[-2].list_evsel);

	/* frees $3 */
	parse_events_update_lists(event, list);
	(yyval.list_evsel) = list;
}
#line 1768 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 16:
#line 224 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct list_head *list = (yyvsp[-1].list_evsel);
	int err;

	/*
	 * Apply modifier on all events added by single event definition
	 * (there could be more events added for multiple tracepoint
	 * definitions via '*?'.
	 */
	err = parse_events__modifier_event(list, (yyvsp[0].str), false);
	free((yyvsp[0].str));
	if (err) {
		struct parse_events_state *parse_state = _parse_state;
		struct parse_events_error *error = parse_state->error;

		parse_events_error__handle(error, (yylsp[0]).first_column,
					   strdup("Bad modifier"), NULL);
		free_list_evsel(list);
		YYABORT;
	}
	(yyval.list_evsel) = list;
}
#line 1795 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 18:
#line 251 "util/parse-events.y" /* yacc.c:1646  */
    {
	int err;

	err = parse_events_name((yyvsp[0].list_evsel), (yyvsp[-1].str));
	free((yyvsp[-1].str));
	if (err) {
		free_list_evsel((yyvsp[0].list_evsel));
		YYNOMEM;
	}
	(yyval.list_evsel) = (yyvsp[0].list_evsel);
}
#line 1811 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 27:
#line 275 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct parse_events_state *parse_state = _parse_state;
	struct list_head *list = NULL, *orig_terms = NULL, *terms= NULL;
	char *pattern = NULL;

#define CLEANUP						\
	do {						\
		parse_events_terms__delete((yyvsp[0].list_terms));		\
		parse_events_terms__delete(orig_terms);	\
		free(list);				\
		free((yyvsp[-1].str));				\
		free(pattern);				\
	} while(0)

	if (parse_events_copy_term_list((yyvsp[0].list_terms), &orig_terms)) {
		CLEANUP;
		YYNOMEM;
	}

	list = alloc_list();
	if (!list) {
		CLEANUP;
		YYNOMEM;
	}
	/* Attempt to add to list assuming $1 is a PMU name. */
	if (parse_events_add_pmu(parse_state, list, (yyvsp[-1].str), (yyvsp[0].list_terms), /*auto_merge_stats=*/false, &(yylsp[-1]))) {
		struct perf_pmu *pmu = NULL;
		int ok = 0;

		/* Failure to add, try wildcard expansion of $1 as a PMU name. */
		if (asprintf(&pattern, "%s*", (yyvsp[-1].str)) < 0) {
			CLEANUP;
			YYNOMEM;
		}

		while ((pmu = perf_pmus__scan(pmu)) != NULL) {
			const char *name = pmu->name;

			if (parse_events__filter_pmu(parse_state, pmu))
				continue;

			if (!strncmp(name, "uncore_", 7) &&
			    strncmp((yyvsp[-1].str), "uncore_", 7))
				name += 7;
			if (!perf_pmu__match(pattern, name, (yyvsp[-1].str)) ||
			    !perf_pmu__match(pattern, pmu->alias_name, (yyvsp[-1].str))) {
				bool auto_merge_stats = perf_pmu__auto_merge_stats(pmu);

				if (parse_events_copy_term_list(orig_terms, &terms)) {
					CLEANUP;
					YYNOMEM;
				}
				if (!parse_events_add_pmu(parse_state, list, pmu->name, terms,
							  auto_merge_stats, &(yylsp[-1]))) {
					ok++;
					parse_state->wild_card_pmus = true;
				}
				parse_events_terms__delete(terms);
			}
		}

		if (!ok) {
			/* Failure to add, assume $1 is an event name. */
			zfree(&list);
			ok = !parse_events_multi_pmu_add(parse_state, (yyvsp[-1].str), (yyvsp[0].list_terms), &list, &(yylsp[-1]));
			(yyvsp[0].list_terms) = NULL;
		}
		if (!ok) {
			struct parse_events_error *error = parse_state->error;
			char *help;

			if (asprintf(&help, "Unable to find PMU or event on a PMU of '%s'", (yyvsp[-1].str)) < 0)
				help = NULL;
			parse_events_error__handle(error, (yylsp[-1]).first_column,
						   strdup("Bad event or PMU"),
						   help);
			CLEANUP;
			YYABORT;
		}
	}
	(yyval.list_evsel) = list;
	list = NULL;
	CLEANUP;
#undef CLEANUP
}
#line 1901 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 28:
#line 362 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct list_head *list;
	int err;

	err = parse_events_multi_pmu_add(_parse_state, (yyvsp[-1].str), NULL, &list, &(yylsp[-1]));
	if (err < 0) {
		struct parse_events_state *parse_state = _parse_state;
		struct parse_events_error *error = parse_state->error;
		char *help;

		if (asprintf(&help, "Unable to find event on a PMU of '%s'", (yyvsp[-1].str)) < 0)
			help = NULL;
		parse_events_error__handle(error, (yylsp[-1]).first_column, strdup("Bad event name"), help);
		free((yyvsp[-1].str));
		PE_ABORT(err);
	}
	free((yyvsp[-1].str));
	(yyval.list_evsel) = list;
}
#line 1925 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 31:
#line 389 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct list_head *list;
	int type = (yyvsp[-3].num) >> 16;
	int config = (yyvsp[-3].num) & 255;
	int err;
	bool wildcard = (type == PERF_TYPE_HARDWARE || type == PERF_TYPE_HW_CACHE);

	list = alloc_list();
	if (!list)
		YYNOMEM;
	err = parse_events_add_numeric(_parse_state, list, type, config, (yyvsp[-1].list_terms), wildcard);
	parse_events_terms__delete((yyvsp[-1].list_terms));
	if (err) {
		free_list_evsel(list);
		PE_ABORT(err);
	}
	(yyval.list_evsel) = list;
}
#line 1948 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 32:
#line 409 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct list_head *list;
	int type = (yyvsp[-1].num) >> 16;
	int config = (yyvsp[-1].num) & 255;
	bool wildcard = (type == PERF_TYPE_HARDWARE || type == PERF_TYPE_HW_CACHE);
	int err;

	list = alloc_list();
	if (!list)
		YYNOMEM;
	err = parse_events_add_numeric(_parse_state, list, type, config, /*head_config=*/NULL, wildcard);
	if (err)
		PE_ABORT(err);
	(yyval.list_evsel) = list;
}
#line 1968 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 33:
#line 426 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct list_head *list;
	int err;

	list = alloc_list();
	if (!list)
		YYNOMEM;
	err = parse_events_add_tool(_parse_state, list, (yyvsp[-1].num));
	if (err)
		YYNOMEM;
	(yyval.list_evsel) = list;
}
#line 1985 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 34:
#line 441 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct parse_events_state *parse_state = _parse_state;
	struct list_head *list;
	int err;

	list = alloc_list();
	if (!list)
		YYNOMEM;

	err = parse_events_add_cache(list, &parse_state->idx, (yyvsp[-1].str), parse_state, (yyvsp[0].list_terms));

	parse_events_terms__delete((yyvsp[0].list_terms));
	free((yyvsp[-1].str));
	if (err) {
		free_list_evsel(list);
		PE_ABORT(err);
	}
	(yyval.list_evsel) = list;
}
#line 2009 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 35:
#line 463 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct list_head *list;
	int err;

	list = alloc_list();
	if (!list)
		YYNOMEM;

	err = parse_events_add_breakpoint(_parse_state, list,
					  (yyvsp[-5].num), (yyvsp[-1].str), (yyvsp[-3].num), (yyvsp[0].list_terms));
	parse_events_terms__delete((yyvsp[0].list_terms));
	free((yyvsp[-1].str));
	if (err) {
		free(list);
		PE_ABORT(err);
	}
	(yyval.list_evsel) = list;
}
#line 2032 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 36:
#line 483 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct list_head *list;
	int err;

	list = alloc_list();
	if (!list)
		YYNOMEM;

	err = parse_events_add_breakpoint(_parse_state, list,
					  (yyvsp[-3].num), NULL, (yyvsp[-1].num), (yyvsp[0].list_terms));
	parse_events_terms__delete((yyvsp[0].list_terms));
	if (err) {
		free(list);
		PE_ABORT(err);
	}
	(yyval.list_evsel) = list;
}
#line 2054 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 37:
#line 502 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct list_head *list;
	int err;

	list = alloc_list();
	if (!list)
		YYNOMEM;

	err = parse_events_add_breakpoint(_parse_state, list,
					  (yyvsp[-3].num), (yyvsp[-1].str), 0, (yyvsp[0].list_terms));
	parse_events_terms__delete((yyvsp[0].list_terms));
	free((yyvsp[-1].str));
	if (err) {
		free(list);
		PE_ABORT(err);
	}
	(yyval.list_evsel) = list;
}
#line 2077 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 38:
#line 522 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct list_head *list;
	int err;

	list = alloc_list();
	if (!list)
		YYNOMEM;
	err = parse_events_add_breakpoint(_parse_state, list,
					  (yyvsp[-1].num), NULL, 0, (yyvsp[0].list_terms));
	parse_events_terms__delete((yyvsp[0].list_terms));
	if (err) {
		free(list);
		PE_ABORT(err);
	}
	(yyval.list_evsel) = list;
}
#line 2098 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 39:
#line 541 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct parse_events_state *parse_state = _parse_state;
	struct parse_events_error *error = parse_state->error;
	struct list_head *list;
	int err;

	list = alloc_list();
	if (!list)
		YYNOMEM;
	if (error)
		error->idx = (yylsp[-1]).first_column;

	err = parse_events_add_tracepoint(list, &parse_state->idx, (yyvsp[-1].tracepoint_name).sys, (yyvsp[-1].tracepoint_name).event,
					error, (yyvsp[0].list_terms), &(yylsp[-1]));

	parse_events_terms__delete((yyvsp[0].list_terms));
	free((yyvsp[-1].tracepoint_name).sys);
	free((yyvsp[-1].tracepoint_name).event);
	if (err) {
		free(list);
		PE_ABORT(err);
	}
	(yyval.list_evsel) = list;
}
#line 2127 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 40:
#line 568 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct tracepoint_name tracepoint = {(yyvsp[-2].str), (yyvsp[0].str)};

	(yyval.tracepoint_name) = tracepoint;
}
#line 2137 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 41:
#line 576 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct list_head *list;
	int err;

	list = alloc_list();
	if (!list)
		YYNOMEM;
	err = parse_events_add_numeric(_parse_state, list, (u32)(yyvsp[-3].num), (yyvsp[-1].num), (yyvsp[0].list_terms),
				       /*wildcard=*/false);
	parse_events_terms__delete((yyvsp[0].list_terms));
	if (err) {
		free(list);
		PE_ABORT(err);
	}
	(yyval.list_evsel) = list;
}
#line 2158 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 42:
#line 595 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct list_head *list;
	int err;
	u64 num;

	list = alloc_list();
	if (!list)
		YYNOMEM;
	errno = 0;
	num = strtoull((yyvsp[-1].str) + 1, NULL, 16);
	/* Given the lexer will only give [a-fA-F0-9]+ a failure here should be impossible. */
	if (errno)
		YYABORT;
	free((yyvsp[-1].str));
	err = parse_events_add_numeric(_parse_state, list, PERF_TYPE_RAW, num, (yyvsp[0].list_terms),
				       /*wildcard=*/false);
	parse_events_terms__delete((yyvsp[0].list_terms));
	if (err) {
		free(list);
		PE_ABORT(err);
	}
	(yyval.list_evsel) = list;
}
#line 2186 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 43:
#line 621 "util/parse-events.y" /* yacc.c:1646  */
    {
	(yyval.list_terms) = (yyvsp[-1].list_terms);
}
#line 2194 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 44:
#line 626 "util/parse-events.y" /* yacc.c:1646  */
    {
	(yyval.list_terms) = NULL;
}
#line 2202 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 45:
#line 630 "util/parse-events.y" /* yacc.c:1646  */
    {
	(yyval.list_terms) = NULL;
}
#line 2210 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 46:
#line 636 "util/parse-events.y" /* yacc.c:1646  */
    {
	(yyval.list_terms) = (yyvsp[-1].list_terms);
}
#line 2218 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 47:
#line 641 "util/parse-events.y" /* yacc.c:1646  */
    {
	(yyval.list_terms) = NULL;
}
#line 2226 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 48:
#line 646 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct parse_events_state *parse_state = _parse_state;
	if (parse_state->terms) {
		parse_events_terms__delete ((yyvsp[0].list_terms));
		YYABORT;
	}
	parse_state->terms = (yyvsp[0].list_terms);
}
#line 2239 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 49:
#line 657 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct list_head *head = (yyvsp[-2].list_terms);
	struct parse_events_term *term = (yyvsp[0].term);

	if (!head) {
		parse_events_term__delete(term);
		YYABORT;
	}
	list_add_tail(&term->list, head);
	(yyval.list_terms) = (yyvsp[-2].list_terms);
}
#line 2255 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 50:
#line 670 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct list_head *head = malloc(sizeof(*head));
	struct parse_events_term *term = (yyvsp[0].term);

	if (!head)
		YYNOMEM;
	INIT_LIST_HEAD(head);
	list_add_tail(&term->list, head);
	(yyval.list_terms) = head;
}
#line 2270 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 54:
#line 685 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct parse_events_term *term;
	int err = parse_events_term__str(&term, PARSE_EVENTS__TERM_TYPE_RAW,
					 strdup("raw"), (yyvsp[0].str), &(yylsp[0]), &(yylsp[0]));

	if (err) {
		free((yyvsp[0].str));
		PE_ABORT(err);
	}
	(yyval.term) = term;
}
#line 2286 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 55:
#line 698 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct parse_events_term *term;
	int err = parse_events_term__str(&term, PARSE_EVENTS__TERM_TYPE_USER, (yyvsp[-2].str), (yyvsp[0].str), &(yylsp[-2]), &(yylsp[0]));

	if (err) {
		free((yyvsp[-2].str));
		free((yyvsp[0].str));
		PE_ABORT(err);
	}
	(yyval.term) = term;
}
#line 2302 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 56:
#line 711 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct parse_events_term *term;
	int err = parse_events_term__num(&term, PARSE_EVENTS__TERM_TYPE_USER,
					 (yyvsp[-2].str), (yyvsp[0].num), /*novalue=*/false, &(yylsp[-2]), &(yylsp[0]));

	if (err) {
		free((yyvsp[-2].str));
		PE_ABORT(err);
	}
	(yyval.term) = term;
}
#line 2318 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 57:
#line 724 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct parse_events_term *term;
	int err = parse_events_term__str(&term, PARSE_EVENTS__TERM_TYPE_USER,
					 (yyvsp[-2].str), (yyvsp[0].hardware_term).str, &(yylsp[-2]), &(yylsp[0]));

	if (err) {
		free((yyvsp[-2].str));
		free((yyvsp[0].hardware_term).str);
		PE_ABORT(err);
	}
	(yyval.term) = term;
}
#line 2335 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 58:
#line 738 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct parse_events_term *term;
	int err = parse_events_term__num(&term, PARSE_EVENTS__TERM_TYPE_LEGACY_CACHE,
					 (yyvsp[0].str), /*num=*/1, /*novalue=*/true, &(yylsp[0]), /*loc_val=*/NULL);

	if (err) {
		free((yyvsp[0].str));
		PE_ABORT(err);
	}
	(yyval.term) = term;
}
#line 2351 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 59:
#line 751 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct parse_events_term *term;
	int err = parse_events_term__num(&term, PARSE_EVENTS__TERM_TYPE_USER,
					 (yyvsp[0].str), /*num=*/1, /*novalue=*/true, &(yylsp[0]), /*loc_val=*/NULL);

	if (err) {
		free((yyvsp[0].str));
		PE_ABORT(err);
	}
	(yyval.term) = term;
}
#line 2367 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 60:
#line 764 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct parse_events_term *term;
	int err = parse_events_term__num(&term, PARSE_EVENTS__TERM_TYPE_HARDWARE,
					 (yyvsp[0].hardware_term).str, (yyvsp[0].hardware_term).num & 255, /*novalue=*/false,
					 &(yylsp[0]), /*loc_val=*/NULL);

	if (err) {
		free((yyvsp[0].hardware_term).str);
		PE_ABORT(err);
	}
	(yyval.term) = term;
}
#line 2384 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 61:
#line 778 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct parse_events_term *term;
	int err = parse_events_term__str(&term, (enum parse_events__term_type)(yyvsp[-2].num),
					/*config=*/NULL, (yyvsp[0].str), &(yylsp[-2]), &(yylsp[0]));

	if (err) {
		free((yyvsp[0].str));
		PE_ABORT(err);
	}
	(yyval.term) = term;
}
#line 2400 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 62:
#line 791 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct parse_events_term *term;
	int err = parse_events_term__str(&term, (enum parse_events__term_type)(yyvsp[-2].num),
					 /*config=*/NULL, (yyvsp[0].hardware_term).str, &(yylsp[-2]), &(yylsp[0]));

	if (err) {
		free((yyvsp[0].hardware_term).str);
		PE_ABORT(err);
	}
	(yyval.term) = term;
}
#line 2416 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 63:
#line 804 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct parse_events_term *term;
	int err = parse_events_term__term(&term,
					  (enum parse_events__term_type)(yyvsp[-2].num),
					  (enum parse_events__term_type)(yyvsp[0].num),
					  &(yylsp[-2]), &(yylsp[0]));

	if (err)
		PE_ABORT(err);

	(yyval.term) = term;
}
#line 2433 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 64:
#line 818 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct parse_events_term *term;
	int err = parse_events_term__num(&term, (enum parse_events__term_type)(yyvsp[-2].num),
					 /*config=*/NULL, (yyvsp[0].num), /*novalue=*/false, &(yylsp[-2]), &(yylsp[0]));

	if (err)
		PE_ABORT(err);

	(yyval.term) = term;
}
#line 2448 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 65:
#line 830 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct parse_events_term *term;
	int err = parse_events_term__num(&term, (enum parse_events__term_type)(yyvsp[0].num),
					/*config=*/NULL, /*num=*/1, /*novalue=*/true,
					&(yylsp[0]), /*loc_val=*/NULL);

	if (err)
		PE_ABORT(err);

	(yyval.term) = term;
}
#line 2464 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;

  case 66:
#line 843 "util/parse-events.y" /* yacc.c:1646  */
    {
	struct parse_events_term *term;
	char *config = strdup((yyvsp[0].str));
	int err;

	if (!config)
		YYNOMEM;
	err = parse_events_term__str(&term, PARSE_EVENTS__TERM_TYPE_DRV_CFG, config, (yyvsp[0].str), &(yylsp[0]), NULL);
	if (err) {
		free((yyvsp[0].str));
		free(config);
		PE_ABORT(err);
	}
	(yyval.term) = term;
}
#line 2484 "util/parse-events-bison.c" /* yacc.c:1646  */
    break;


#line 2488 "util/parse-events-bison.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, _parse_state, scanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, _parse_state, scanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, _parse_state, scanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp, _parse_state, scanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, _parse_state, scanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, _parse_state, scanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp, _parse_state, scanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 863 "util/parse-events.y" /* yacc.c:1906  */


void parse_events_error(YYLTYPE *loc, void *parse_state,
			void *scanner __maybe_unused,
			char const *msg __maybe_unused)
{
	parse_events_evlist_error(parse_state, loc->last_column, "parser error");
}
